/* Roman Belousov
 * romanb@u.washington.edu
 * 5/18/99
 * CSE142, Spring 1999
 * Section BE
 * Homework 4A
 * Traffic animation

  
/*	NOTE!: having a splash screen and adding the wind factor are the ONLY ideas
I got from seeing the programs of people from previous quarters.  Even then, 
none of their actual code was coppied. */

/* SO FAR I HAVE MADE THE FOLLOWING CHANGE TO THOSE ALREADY INCLUDED:
	* - Black line down center of road
	* - Go button works after Stop
	* - Car goes to opposite end of screen after leaving one end
	* - Change of landscape from night to day
	* - Multi car support
	* - Parellel road
	* - Changed landscape colors
	* - Ability to add cars
	* - User can select cars: selected car has an arrow over its head
	* - user can make changes to selected cars
	* - different speeds for different cars
	* - add random trees
	* - speed up sun/time button: EFFECTS ALL ANIMATION
	* - added clouds
	* - added stars @ night
	* - added ability to change cars into trucks
	* - when the trucks turn, they change direction
		:.since they are not symmetric like the cars
	* - added snow
	* - added a lake
	* - ability to remove cars
 * NEW WITH THIS UPDATE:
	* - added "typedef's" to improve readability
	* - cars start in random directions
	* - cars appear in random colors
	* - cars start as random types
	* - added some keyboard support
	* - make the clouds move
	* - announce which keys are what on splash screen
	* - added more/less cloud buttons
	* - added more/less snow buttons
	* - added more/less wind buttons: EFFECTS SNOW AND CLOUDS
 * STILL MIGHT BE LOOKING TO ADD:
*/


#include "gp142.h"
#include <stdio.h>
#include <math.h>
#include <time.h>
/* 
 * <time.h> is included so the current time can be accessed
 * to initialize the random number generator.  
*/

/* Logical constants */
#define TRUE    		1
#define FALSE   		0

/* 
 * For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.  The
 * constant FILL is used in function calls when a solid
 * shape is desired.
 */
#define FILL 0


/*
 * Symbolic constants.  Change as needed.
 */

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	17
#define BUTTON_WIDTH 	75

/* Number of buttons */
#define NUM_BUTTONS 17


/* Possible locations of mouse clicks: */
/*   Mouse click in some button */
#define BUTTON_CLICK 1
/*   Mouse click elsewhere */
#define OTHER_CLICK 0


/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10
#define HIGHWAY2_CENTER (HIGHWAY_CENTER - 30)
#define HIGHWAY2_WIDTH  10

/* Maximum number of vehicles that can appear in the animation */
#define MAX_VEHICLES 15

/* Height and width of a single car or truck	*/
#define CAR_HEIGHT 24
#define CAR_WIDTH  40
#define TRUCK_HEIGHT 25 
#define TRUCK_WIDTH 60

/*STARS:									*/
/* number of stars to be used in the scene	*/
/* min and max sizes the stars can be		*/
/* the point where the color changes changes* 
 * shade to give 3d effect					*/
#define STARS 35
#define STAR_MIN 4
#define STAR_MAX 9
#define STAR_COLOR_PT 7

/* SNOW_FLAKES:																*/
/* number of snow flakes; make sure this number is always divisible	
    by 10, because the add snow button adds 10 flakes per click							
 * min and max sizes of the flakes									  		*
 * the amount by which snow increases or decreases with each button click	*/
#define MAX_SNOWFLAKES 200
#define SNOW_MIN 7
#define SNOW_MAX 15
#define SNOW_SPEED_MIN 3
#define SNOW_SPEED_MAX 10
#define SNOW_DISPLACEMENT 10

/* TREES: 
 * number of trees in picture, their maximum and minimus heights and widths *
 * min and max tree heights, and widths										*/
#define TREES 30
#define MAX_TREE_H 100
#define MIN_TREE_H 50
#define MAX_TREE_W 50
#define MIN_TREE_W 25

/* CLOUDS:
/* same as with the stuff above... */
#define MAX_CLOUDS 20
#define CLOUD_MIN 50
#define CLOUD_MAX 150
#define CLOUD_SPEED_MIN 1
#define CLOUD_SPEED_MAX 4

/* the most possible wind	*/
#define MAX_WIND 5

/* the size of the sun		*/
#define SUN_SIZE 20

/* this type declares whether the object if a car or truck */
typedef enum 
	{a_truck, a_convertible}
car_type_t;

/* car information */
typedef struct {
	/* the car's coordinates */
	int x[MAX_VEHICLES];
	int	y[MAX_VEHICLES];
	/* current direction: +1=right, -1=left	*/
	int direction[MAX_VEHICLES];
	/* color of the car								*/
	int color[MAX_VEHICLES];
	/* speed in pixels per tick when traffic moving	*/	
	int speed[MAX_VEHICLES];		
	/* whether the car is a truck or convertible    */
	car_type_t type[MAX_VEHICLES];
} car_t;

/* sun information */
typedef struct {
	int x;
	int	y;
	int speed;
} sun_t;

/* tree information */
typedef struct {
	int x[TREES];
	int	y[TREES];
	int width[TREES];
	int height[TREES];
} tree_t;

/* star information */
typedef struct {
	int x[STARS];
	int	y[STARS];
	int size[STARS];
	int color[STARS];
} star_t;

/* snowflake information */
typedef struct {
	int x[MAX_SNOWFLAKES];
	int	y[MAX_SNOWFLAKES];
	int size[MAX_SNOWFLAKES];
	int end[MAX_SNOWFLAKES];
	int speed[MAX_SNOWFLAKES];
	int number;
} snow_t;

/* cloud information */
typedef struct {
	int x[MAX_CLOUDS];
	int	y[MAX_CLOUDS];
	int width[MAX_CLOUDS];
	int height[MAX_CLOUDS];
	int speed[MAX_CLOUDS];
	int number;
} cloud_t;



/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
void initialize_random_numbers();

/* NOTE!: I replaced the draw_landscape function with draw_background and draw_sky
		  because the other got too big */

/* draws the mountains, forest, ground and highway */
void draw_background(int day,tree_t tree);

/* draws the sun, moon, clouds, and stars */
void draw_sky(int day,sun_t sun, star_t star);

/* draw snowflakes */
void draw_snow(int day,int sun_speed,int wind,snow_t *snow);

/* Draws a tree */
void make_tree(int x, int y, int w, int h, int day);

/* updates the clouds info */
void draw_clouds(int day, int sun_speed, int wind,cloud_t *cloud);

/* Draws a cloud */
void make_cloud(int x, int y, int w, int h, int day);

/* draws the lake */
void draw_lake(int x, int y, int w, int h, int day);

/* Draws the buttons */
void draw_buttons(int day);

/* Return kind of mouse click (in a button, etc.) */
int classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x,int y,int *traffic_moving,car_t *car,int *cars,
				int cur_car,int *sun_speed,snow_t *snow,int *wind,cloud_t *cloud);

/* the following gives a 'pretend' value where the mouse would have to have cliked 
 * for each button */
int handle_key(int key_pressed);

/* Update sun coordinates sun_x, sun_y for one tick */
int move_sun(sun_t *sun, int *day);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(car_t *car,int cars, int sun_speed);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(car_t car, int cars, int cur_car);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color, int cur_car, int car_type, int dir);

/* Display error message if internal error is detected. */
void something_is_wrong (void);

/* generate random numbers ranging from min to max */
int rand_num(int min, int max);

/* display the splash screen */
void draw_splash_screen(void);


/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/

	car_t car;				/* contains all the car info	*/
	sun_t sun;				/* contains all the sun info	*/
	tree_t tree;			/* contains all the tree info	*/
	star_t star;			/* contains all the star info	*/
	snow_t snow;			/* contains all the snow info	*/
	cloud_t cloud;			/* contains all the cloud into	*/
	
	/* initial wind			*/
	int wind = 0;

	int traffic_moving;		
	/* whether its night or day						*/
	int day = FALSE;		
	/* number of cars in play						*/
	int cars = 1;		
	/* the car currently highlighted for changes	*/
	int cur_car = 0;
	
	/* used to 'pretend' the mouse clicked a button at certain coordinates, 
	 * in order to correspond key presses with screen buttons				*/
	int imaginary_x;
	int imaginary_y;
	
	/* for use in for loops							*/
	int i;					
	
	initialize_random_numbers();
	
	/* set initial location and speed of the sun		*/
	/* speed dictates the speed of the passage of time	*/
	sun.x = GP142_XMAX - 50;
	sun.y = GP142_YMAX - 35;
	sun.speed = 1;

	/* set the number of initial number clouds and flakes to zero	*/
	cloud.number=0;
	snow.number=0;

	/* randomly set location of trees and how they'll look */
	for (i=0; i<TREES; i++){
		tree.y[i] = rand_num(HIGHWAY_CENTER+HIGHWAY_WIDTH/2, HORIZON-25);
		tree.x[i] = rand_num(-GP142_XMAX,GP142_XMAX);
		tree.width[i] = rand_num(MIN_TREE_W,MAX_TREE_W);
		tree.height[i] = rand_num(MIN_TREE_H,MAX_TREE_H);
	}	

	
	/* set the initial conditions or stars: they will appear in random		
	 * locations above the mountains and those of larger size will be more	 
	 * visible by being brighter											
	 */
	for (i=0; i<STARS; i++){
		star.y[i] = rand_num(100,GP142_YMAX);
		star.x[i] = rand_num(-GP142_XMAX,GP142_XMAX);
		star.size[i] = rand_num(STAR_MIN,STAR_MAX);
		if (star.size[i]>STAR_COLOR_PT)
			star.color[i] = WHITE;
		else
			star.color[i] = LT_GRAY;
	}	

	
	/* set the initial conditions or snow: they will appear in random locations 
	 * and those that go off the screen will reappear in random locations from	
	 * the top																	
	 * note: snow.end dictates the y coordinate where the flake reaches the		
	 * point when it is 'reincarnated' up top 
	 */
	for (i=0;i<MAX_SNOWFLAKES;i++){
		snow.y[i] = rand_num(snow.end[i],GP142_YMAX);
		snow.x[i] = rand_num(-GP142_XMAX,GP142_XMAX);
		snow.size[i] = rand_num(SNOW_MIN,SNOW_MAX);
		snow.speed[i] = rand_num(SNOW_SPEED_MIN,SNOW_SPEED_MAX);
		snow.end[i]= rand_num(HIGHWAY2_CENTER-HIGHWAY_WIDTH,
							  HIGHWAY_CENTER+HIGHWAY_WIDTH);
	}

	for (i=0;i<MAX_CLOUDS;i++) {
		cloud.width[i] = rand_num(CLOUD_MIN,CLOUD_MAX);
		cloud.height[i]= rand_num(cloud.width[i]/6,cloud.width[i]/2);
		cloud.y[i] = rand_num(155,GP142_YMAX-cloud.height[i]/2);
		cloud.x[i] = rand_num(-GP142_XMAX,GP142_XMAX);
		cloud.speed[i] = rand_num(CLOUD_SPEED_MIN,CLOUD_SPEED_MAX);
	}

		
	/* set some properties of the first car */
	car.x[i] = 0;
	car.y[0] = HIGHWAY_CENTER;
	car.color[0] = RED;
	car.speed[0] = 5;
	car.direction[0] = +1;
	traffic_moving = TRUE;
	/* set the vehicle to be a convertible */
	car.type[0]=a_convertible;
	
		
	/* Initialize graphics package: clear the window, turn off the 
	 * annoying text window, turn logging off, and start animation.
	 */
	GP142_open();
	GP142_show_text(FALSE);
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* stall while the program allocates all the required memory and whatnot */
	draw_splash_screen();
	quit=FALSE;
	while (!quit) {    
		switch (GP142_await_event(&mouse_x, &mouse_y, &key_pressed)) {
    	case GP142_QUIT:
			quit = TRUE;          
			break;    
	
		case GP142_MOUSE:
			quit = TRUE;
			break;
		}
	}

	GP142_clear();

	/* Draw initial landscape, trees, buttons, and traffic */
	draw_sky(day,sun,star);
	draw_background(day,tree);
	draw_traffic(car, cars, cur_car);
	draw_buttons(day);

	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	/* reset 'quit' */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			/* this works by 'pretending that the mouse was cliked on the right 
			 * place for each button, then sending the arguments to handle_button
			 */
			imaginary_y=handle_key(key_pressed);
			imaginary_x = MENU_TOP + 1;
			if (imaginary_y !=FALSE)
				handle_button(imaginary_x, imaginary_y, &traffic_moving, &car,
				              &cars,cur_car, &sun.speed, &snow,&wind, &cloud);
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, &traffic_moving, &car, &cars,
					          cur_car, &sun.speed, &snow,&wind, &cloud);
			} else {
				/* sets cur_car to the car user clicked		*/
				for (i=0;i<cars;i=i+1){
					if ((mouse_x >= car.x[i]-CAR_WIDTH/2) && 
						(mouse_x <= car.x[i]+CAR_WIDTH/2) &&
						(mouse_y >= car.y[i]) && 
						(mouse_y <= car.y[i]+CAR_HEIGHT))
												
						cur_car = i;
						
				} /* end for		*/
			} /* end if click_kind	*/
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			day = move_sun(&sun, &day);
			if (traffic_moving)
				move_traffic(&car, cars, sun.speed);
			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		/* Redraw everything */
		draw_sky(day,sun,star);
		draw_background(day,tree);
		
		/* dont bother drawing snow if there isnt any		*/
		if (snow.number!=0)
			draw_snow(day,sun.speed,wind,&snow);

		draw_traffic(car, cars, cur_car);
		
		/* dont bother drawing clouds if there arent any	*/
		if (cloud.number!=0)
			draw_clouds(day,sun.speed,wind,&cloud);

		draw_buttons(day);
				
	}  /* end event loop */
	
	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;

}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/

/* Draw the sky, sun, moon, clouds and stars */
void draw_sky(int day,sun_t sun,star_t star)
{	
	/* set the colors of the sky and sun						*/
	/* array index corresponds to the value for day (0 or 1)	*/
	int sky_color[]  = {NAVY_BLUE,BLUE};
	int sun_color[] = {WHITE,YELLOW};
	
	/* to use in for loops */
	int i;		
	
	/*draw the sky */
	GP142_rectangleXY(sky_color[day], -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	/*Draw some stars if its night rather than day*/ 
	if (day==FALSE) { 
		for (i=0;i<STARS;i++)
			GP142_printfXY (star.color[i],star.x[i],star.y[i],star.size[i],"*");
	}

	/* Draw the sun or moon */
	GP142_circleXY(sun_color[day], sun.x, sun.y , SUN_SIZE);
	
} /* end draw_sky */



/* Draw the ground, highway, trees, and text legend */
void draw_background(int day,tree_t tree)
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text */
	int text_size = 12;					/* size of text font */
	int i;								/* to use in for loops */
	
	/* set the colors */
	/* array index corresponds to the value for day (0 or 1)	*/
	int ground_color[] = {LT_GRAY, WHITE}; /* brown, peach}		*/
	int high_color[] = {MED_GRAY,LT_GRAY};
	int text_color[] = {LT_GRAY,BLACK};
	int moutn_color[2][3] ={{BLACK, OLIVE, BROWN},{MED_GRAY, GOLD, ORANGE}};


	/* draw highway  and ground*/
	GP142_rectangleXY(ground_color[day], -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);
	GP142_rectangleXY(high_color[day], 
					-GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER + HIGHWAY_WIDTH,
					 FILL);
	
	GP142_rectangleXY(high_color[day], 
					-GP142_XMAX, HIGHWAY2_CENTER - HIGHWAY2_WIDTH,
					 GP142_XMAX, HIGHWAY2_CENTER + HIGHWAY2_WIDTH,
					 FILL);

	GP142_lineXY(BLACK,-GP142_XMAX,HIGHWAY_CENTER,GP142_XMAX,HIGHWAY_CENTER,1);
	GP142_lineXY(BLACK,-GP142_XMAX,HIGHWAY2_CENTER,GP142_XMAX,HIGHWAY2_CENTER,1);

	/* text */
	GP142_printfXY (text_color[day], text_offset, -GP142_YMAX+30, text_size,
		"Click a button to control the car.");
	
	
	/*Draw some mountains */
	GP142_triangleXY(moutn_color[day][0],
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);
	
	GP142_triangleXY(moutn_color[day][1],
		-( 5 * GP142_XMAX/4), HORIZON,
		(GP142_XMAX)/3  , HORIZON,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);
	
	GP142_triangleXY(moutn_color[day][2],
		-GP142_XMAX / 3 , HORIZON,
		GP142_XMAX, HORIZON,
		GP142_XMAX, (2 * GP142_YMAX)/3 ,
		FILL);

	/* draw the trees */
	for (i=0; i<TREES; i++)
		make_tree(tree.x[i], tree.y[i], tree.width[i], tree.height[i], day);

	/* draw the lake */
	draw_lake(-50,-300,450,125, day);

} /* end draw_background */



/* sets up the cloud info and calls on make_cloud to draw them */
void draw_clouds(int day, int sun_speed,int wind,cloud_t *cloud){
	int i;
	for (i=0; i<cloud->number; i++){
		cloud->x[i]=cloud->x[i]-
					  cloud->speed[i] * sun_speed * (int)((wind+1.5)/3.0);
		if (cloud->x[i] < -GP142_XMAX - cloud->width[i]) {
			cloud->x[i]=GP142_XMAX-10;
			cloud->width[i] = rand_num(CLOUD_MIN,CLOUD_MAX);
			cloud->height[i]= rand_num(cloud->width[i]/6,cloud->width[i]/2);
			cloud->y[i] = rand_num(155,GP142_YMAX-cloud->height[i]/2);
			cloud->speed[i] = rand_num(CLOUD_SPEED_MIN,CLOUD_SPEED_MAX);
		}
		make_cloud(cloud->x[i],cloud->y[i],
				   cloud->width[i],cloud->height[i], day);
	}
}


/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons(int day)
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	int color;
	
	/* make sure that the buttons are always visible,	*/
	/* by chanding their color with day					*/
	if (day==FALSE)
		color = LT_GRAY;
	else
		color = BLACK;

	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(BLACK,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(color, text_offset, i, font_size, "Go");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Stop");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Speed Time");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Slow Time");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "New Color");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Change Car");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Add Car");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Remove Car");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "+ Cloud");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "- Cloud");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "+ Snow");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "- Snow");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "+ Wind");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "- Wind");


} /* end draw_buttons */


/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int *traffic_moving,car_t *car,int *cars,
				  int cur_car,int *sun_speed,snow_t *snow,int *wind,cloud_t *cloud)
{
	int type_car;		/* check whether its a truck or convertible	*/
	int buttonNum;		/* number of selected button		*/
	int i;

	/* Convert y coordinate to button number from top.		*/
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;
	
	switch(buttonNum) {
	case 0:
		/* go */
		*traffic_moving = TRUE;
		break;
	case 1:
		/* stop all traffic */
		*traffic_moving = FALSE;
		break;
		
	case 2:
		/* speed up the time: all animation goes faster		*/
		*sun_speed = *sun_speed + 1;
		break;
	case 3:
		/* slow the time: all animation goes slower			*/
		if (*sun_speed > 0)
			*sun_speed = *sun_speed - 1;
		break;

	case 4:
		/* speed up individual car	*/
		car->speed[cur_car] = car->speed[cur_car] + 1;
		break;
	case 5:
		/* slow down individual car	*/
		car->speed[cur_car] = car->speed[cur_car] - 1;
		if (car->speed[cur_car] < 0)
			car->speed[cur_car] = 0;
		break;
		
	case 6:
		/* reverse individual car	*/
		car->direction[cur_car] = - car->direction[cur_car];
		break;
	case 7:
		/* change car color	*/
		car->color[cur_car] = (car->color[cur_car]+1) % MAX_COLORS;
		break;
	case 8:
		/* change car type	*/
		car->type[cur_car] = !car->type[cur_car];
		break;

	case 9:
		/* add another car to the mix and set its initial info */
		if (*cars < MAX_VEHICLES) {
			*cars = *cars + 1;
			car->direction[*cars-1] = -1 * car->direction[*cars - 2];
			car->speed[*cars -1] = rand_num(3,9);
			car->color[*cars-1] = rand_num(0,MAX_COLORS-1);
			car->x[*cars -1] = 0;
			if (*cars % 2 == 0)
				car->y[*cars -1] = HIGHWAY2_CENTER;
			else 
				car->y[*cars -1] = HIGHWAY_CENTER;
			type_car = rand_num(1,4);
			/* make roughly 1 in 4 be a truck */
			if (type_car==4)
				car->type[*cars -1] = a_truck;
			else
				car->type[*cars -1] = a_convertible;

		}

		break;
	case 10:
		/* remove selected car and update the arrays */
		if (*cars > 1){
			*cars=*cars-1;
			for (i=cur_car;i<*cars;i++){
				car->x[i] = car->x[i+1];
				car->y[i] = car->y[i+1] ;
				car->direction[i] = car->direction[i+1];
				car->speed[i] = car->speed[i+1];
				car->color[i] = car->color[i+1];
				car->type[i]=car->type[i+1];
			}
		}
		break;
	case 11:
		/* add cloud */
		if (cloud->number < MAX_CLOUDS)
			cloud->number = cloud->number+1;
		break;
	case 12:
		/* remove cloud */
		if (cloud->number > 0)
			cloud->number = cloud->number-1;
		break;
	case 13:
		/* add snow */
		if (snow->number<MAX_SNOWFLAKES)
			snow->number=snow->number+SNOW_DISPLACEMENT;
		break;
	case 14:
		/* remove snow */
		if (snow->number>0)
			snow->number=snow->number-SNOW_DISPLACEMENT;
		break;
	case 15:
		/* more wind */
		if (*wind < MAX_WIND)	
			*wind=*wind+1;
		break;
	case 16:
		/* less wind */
		if (*wind > 0)
			*wind=*wind-1;
		break;
	default:
		break; 
	} /* end switch (buttonNum) */
} /* end handle_button */


  
/* this works by 'pretending that the mouse was cliked on the right 
 * place for each button, then sending the arguments to handle_button
 */
int handle_key(int key_pressed){
	int imaginary_y;
	switch (key_pressed) {
	case 'g':	/* go */
	case 'G':
		imaginary_y=MENU_TOP;
		break;
	case 's':	/* stop */
	case 'S':
		imaginary_y =MENU_TOP-BUTTON_HEIGHT;
		break;
	case ']':	/* speed time */
		imaginary_y=MENU_TOP-2*BUTTON_HEIGHT;
		break;
	case '[':	/* slow time  */
		imaginary_y=MENU_TOP-3*BUTTON_HEIGHT;
		break;
	case '+':	/* speed car */
		imaginary_y=MENU_TOP-4*BUTTON_HEIGHT;
		break;
	case '-':	/* slow car */
		imaginary_y=MENU_TOP-5*BUTTON_HEIGHT;
		break;
	case 'r':	/* put car in reverse */
	case 'R':
		imaginary_y=MENU_TOP-6*BUTTON_HEIGHT;
		break;
	case 'C':	/* change color */
	case 'c':
		imaginary_y=MENU_TOP-7*BUTTON_HEIGHT;
		break;
	case 't':	/* change type */
	case 'T':
		imaginary_y=MENU_TOP-8*BUTTON_HEIGHT;
		break;
	case 'a':	/* add a car */
	case 'A':
		imaginary_y=MENU_TOP-9*BUTTON_HEIGHT;
		break;
	case '\b':	/* (backspace) remove a car */
		imaginary_y=MENU_TOP-10*BUTTON_HEIGHT;
		break;
	default:
		imaginary_y=FALSE;
		break;
	}
	return imaginary_y;
}		


/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update sun coordinates sun.x, sun.y by the ticks dictated by sun.speed */
int move_sun(sun_t *sun, int *day) {
	
	/* Move the sun to the left.  If it reaches the edge, move it */
	/* to the other side and down a bit. */
	sun->x=sun->x - sun->speed;
	if (sun->x < -GP142_XMAX -30) {
		*day = !(*day);
		sun->x = - sun->x;
		(sun->x)= (sun->x) - sun->speed;
	}
	return *day;
}


/* draws the snowflakes and updates their locations */
void draw_snow(int day, int sun_speed,int wind, snow_t *snow)
{
	int i;
	int color;
	
	/* make sure that the flakes look paler at night */
	if (day==FALSE)
		color = LT_GRAY;
	else
		color = WHITE;

	for (i=0;i<snow->number;i++) {
		if (abs(snow->x[i]) > GP142_XMAX)
			snow->x[i]=-snow->x[i];
		if (snow->y[i] < snow->end[i]){
			snow->y[i] = GP142_YMAX;
			snow->x[i] = rand_num(-GP142_XMAX,GP142_XMAX);
			snow->size[i] = rand_num(SNOW_MIN,SNOW_MAX);
			snow->speed[i] = rand_num(SNOW_SPEED_MIN,SNOW_SPEED_MAX);
		} /* end if */
		
		GP142_printfXY (color,snow->x[i],snow->y[i],snow->size[i],"*");
		snow->y[i] = snow->y[i]-snow->speed[i] * sun_speed;
		/* the 2 is just stuck in here, because i thought it looked better */
		snow->x[i] = snow->x[i] - wind * sun_speed;
	} /* end for */

} /* end draw snow */



/* Update all vehicle x, y coordinates, given current x, y		*/
/* location, direction (+1 or -1), and speed in pixels per tick	*/
void move_traffic(car_t *car, int cars, int sun_speed) {
	int trial_x,i;		/* new value for x coordinate */

	for (i=0; i < cars; i = i+1) {
		/* move vehicle.  If it moves off the edge, restart from opposite side */
		/* speed of movement depends in direction, car speed and speed of time */
		trial_x = car->x[i] + 
				  (car->direction[i] * car->speed[i] * sun_speed);
		if (abs(trial_x) > (GP142_XMAX + CAR_WIDTH/2))
			car->x[i] = -trial_x;
		else
			car->x[i] = trial_x;
	}
}


/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(car_t car, int cars, int cur_car){
	int i;

	for (i = 0; i < cars; i= i+1) {
		if (cur_car==i)
			draw_car(car.x[i],car.y[i],car.color[i],TRUE, car.type[i], 
			car.direction[i]);
		else
			draw_car(car.x[i],car.y[i],car.color[i],FALSE, car.type[i], 
			car.direction[i]);
	}	
}


/* Draw a single car or truck of the given color with horizontal */
/* center x and bottom y */
void draw_car(int x, int y, int color, int car_selected, int car_type, int dir) {
	int w,h;
		
	if (car_type==a_convertible){
		w = CAR_WIDTH;
		h = CAR_HEIGHT;
		
		GP142_rectangleXY(color, x - w/2, y + h/4,
							x + CAR_WIDTH/2, y + h*3/4, FILL);
		GP142_rectangleXY(color, x - w/6, y + h*3/4,
							x + w/6, y + h, FILL);
		GP142_circleXY(BLACK, x - w/4, y + h/4, h/4);
		GP142_circleXY(BLACK, x + w/4, y + h/4, h/4);
		
	} /* end if (car.type==a_convertible) */
	
	else{

		w = TRUCK_WIDTH;
		h = TRUCK_HEIGHT;
		/* make sure the truck has reverse direction when its in reverse, since
		 * its not symmetric like the convertible								*/
		if (dir < 0)
			w=-w;	
		
		GP142_rectangleXY(color, x-w/2, y+h,x+w/12, y+h/4, FILL);
		GP142_rectangleXY(color, x+w/12,y+h/2,x+w/6,y+h/4, FILL);
		GP142_rectangleXY(color, x+w/6,y+h/4*3,x+w/2,y+h/4, FILL);
		GP142_rectangleXY(color, x+w/6,y+h,x+w/3,y+h/4*3, FILL);
		GP142_triangleXY(color, x+w/3,y+h,x+w/3,y+h/4,x+w/2,y+h/4*3, FILL);
		GP142_circleXY(BLACK,x-w/3,y+h/4,h/4);
		GP142_circleXY(BLACK,x-w/12,y+h/4,h/4);
		GP142_circleXY(BLACK,x+w/3,y+h/4,h/4);
		
	} /* end else if (car.type==a_truck) */
	
	
	/* if the vehicle is selected, draw an arrow over it */
	if (car_selected == TRUE)
			GP142_triangleXY(BLACK, x - w/16, y + h/4*5+2 , x + w/16,
							 y + h/4*5+2, x, y+ h+2, FILL);

} /* end draw car */


/* creates a tree with provided coordinates, height and width					*/
/* NOTE: 'day' is included, in case later, i want daytime to reflect tree color	*/
void make_tree(int x, int y, int w, int h, int day) {
	GP142_rectangleXY(BLACK,x+w/5*2,y+h/5,x+w/5*3,y+h/10, FILL);
	GP142_triangleXY(FOREST_GREEN,x,y+h/5,x+w,y+h/5,x+w/2,y+h/5*3, FILL);
	GP142_triangleXY(FOREST_GREEN,x+w/6,y+h/2,x+w/6*5,y+h/2,x+w/2,y+h/5*4, FILL);
	GP142_triangleXY(FOREST_GREEN,x+w/3,y+h/4*3,x+w/3*2,y+h/4*3,x+w/2,y+h, FILL);
}


/* allows the programmer to make seemingly different clouds,*/ 
/* although the designs have the same scheme				*/
void make_cloud(int x, int y, int w, int h, int day) {
	int color;
	
	/* make sure the clouds are paler at night */
	if (day==FALSE)
		color = MED_GRAY;
	else
		color = LT_GRAY;

	GP142_ovalXY(color,x,y+h/5*4,x+w/5*2,y+h/5, FILL);
	GP142_ovalXY(color,x+w/15*4,y+h/10*6,x+w/3*2,y,FILL);
	GP142_ovalXY(color,x+w/5,y+h/10*9,x+w/15*7,y+h/2, FILL);
	GP142_ovalXY(color,x+w/5*2,y+h,x+w/5*4,y+h/5*2, FILL);
	GP142_ovalXY(color,x+w/15*8,y+h/10*9,x+w/15*14,y+h/10*3, FILL);
	GP142_ovalXY(color,x+w/15*11,y+h/10*9,x+w,y+h/2, FILL);
}

/* this is actually a copy of the clouds code with different colors, 
because i was did not want to draw out another design on paper,
however this can be changed at any time */
void draw_lake(int x, int y, int w, int h, int day) {
	int color;
	
	/* make sure the lake looks darker at night */
	if (day==FALSE)
		color = BLUE;
	else
		color = ICE_BLUE;

	GP142_ovalXY(color,x,y+h/5*4,x+w/5*2,y+h/5, FILL);
	GP142_ovalXY(color,x+w/15*4,y+h/10*6,x+w/3*2,y,FILL);
	GP142_ovalXY(color,x+w/5,y+h/10*9,x+w/15*7,y+h/2, FILL);
	GP142_ovalXY(color,x+w/5*2,y+h,x+w/5*4,y+h/5*2, FILL);
	GP142_ovalXY(color,x+w/15*8,y+h/10*9,x+w/15*14,y+h/10*3, FILL);
	GP142_ovalXY(color,x+w/15*11,y+h/10*9,x+w,y+h/2, FILL);
}
/*****************************************************************************

     OTHER

*****************************************************************************/

/* Initialize random number generator */
void initialize_random_numbers() {
	time_t t;			/* current time */
	srand (time(&t));
} 


/* generates a random number from 'min' to 'max' */
/* this works because rand() generates a random number from 1 to 32767 */
int rand_num(int min, int max) {
	return (int)((double)rand() / 32767.0 * (double)(max-min+1) + min );
}

/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}

/* displays the splash screen, which has all sorts of useless information */
void draw_splash_screen (void) {
	GP142_rectangleXY(BLACK,GP142_XMAX,GP142_YMAX,-GP142_XMAX,-GP142_YMAX,FILL);
	GP142_printfXY(WHITE,-270,100,23, 
		          "Click on the screen to see the wonders of the C-highway");
	GP142_printfXY(WHITE,-220,0,20, "Shortcut Keys:");
	GP142_printfXY(WHITE,-200,-20,15, "'G' - Move Traffic");
	GP142_printfXY(WHITE,-200,-40,15, "'S' - Stop Traffic");
	GP142_printfXY(WHITE,-200,-60,15, "']' - Speed Time");
	GP142_printfXY(WHITE,-200,-80,15, "'[' - Slow Time");
	GP142_printfXY(WHITE,-200,-100,15, "'+' - Speed Car");
	GP142_printfXY(WHITE,-200,-120,15, "'-' - Slow Car");
	GP142_printfXY(WHITE,-200,-140,15, "'R' - Reverse Car");
	GP142_printfXY(WHITE,-200,-160,15, "'C' - Change Color");
	GP142_printfXY(WHITE,-200,-180,15, "'T' - Change Car Type");
	GP142_printfXY(WHITE,-200,-200,15, "'A' - Add a Car");
	GP142_printfXY(WHITE,-200,-220,15, "'BS' - Remove a Car");
}